const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const companies = sequelize.define(
    'companies',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

legal_name: {
        type: DataTypes.TEXT,
      
      

      },

tax_number: {
        type: DataTypes.TEXT,
      
      

      },

support_email: {
        type: DataTypes.TEXT,
      
      

      },

support_phone: {
        type: DataTypes.TEXT,
      
      

      },

website: {
        type: DataTypes.TEXT,
      
      

      },

timezone: {
        type: DataTypes.TEXT,
      
      

      },

default_currency: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  companies.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







    db.companies.hasMany(db.branches, {
      as: 'branches_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });



    db.companies.hasMany(db.vehicles, {
      as: 'vehicles_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.rate_plans, {
      as: 'rate_plans_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });



    db.companies.hasMany(db.extras, {
      as: 'extras_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.insurance_plans, {
      as: 'insurance_plans_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.promo_codes, {
      as: 'promo_codes_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.bookings, {
      as: 'bookings_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });





    db.companies.hasMany(db.messages, {
      as: 'messages_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.notification_templates, {
      as: 'notification_templates_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });


    db.companies.hasMany(db.tasks, {
      as: 'tasks_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });




    db.companies.hasMany(db.audit_events, {
      as: 'audit_events_company',
      foreignKey: {
          name: 'companyId',
      },
      constraints: false,
    });



//end loop



    db.companies.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.companies.hasMany(db.file, {
      as: 'logo',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.companies.getTableName(),
        belongsToColumn: 'logo',
      },
    });


    db.companies.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.companies.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return companies;
};


